'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _highlight = require('./highlight');

var _highlight2 = _interopRequireDefault(_highlight);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SpeechView = function (_React$Component) {
  (0, _inherits3.default)(SpeechView, _React$Component);

  function SpeechView(props) {
    (0, _classCallCheck3.default)(this, SpeechView);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(SpeechView).call(this, props));

    _this.handleClick = _this.handleClick.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(SpeechView, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      if (nextProps.highlights.equals(this.props.highlights) && nextProps.progress === this.props.progress) {
        return false;
      } else {
        return true;
      }
    }
  }, {
    key: 'handleClick',
    value: function handleClick() {
      this.props.onClick(this.props.start);
    }
  }, {
    key: 'applyHighlights',
    value: function applyHighlights() {
      return (0, _highlight2.default)(this.props.text, this.props.highlights).map(function (_ref, index) {
        var _ref2 = (0, _slicedToArray3.default)(_ref, 2);

        var highlighted = _ref2[0];
        var text = _ref2[1];
        return highlighted ? _react2.default.createElement(
          'strong',
          { key: index },
          text
        ) : _react2.default.createElement(
          'span',
          { key: index },
          text
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var className = 'speech ' + this.props.progress;
      if (this.props.highlights.size > 0) className += ' highlighted';
      return _react2.default.createElement(
        'span',
        {
          className: className,
          onClick: this.handleClick
        },
        this.applyHighlights()
      );
    }
  }]);
  return SpeechView;
}(_react2.default.Component);

SpeechView.propTypes = { highlights: _react2.default.PropTypes.instanceOf(_immutable2.default.List),
  onClick: _react2.default.PropTypes.func.isRequired,
  progress: _react2.default.PropTypes.string,
  start: _react2.default.PropTypes.number.isRequired,
  text: _react2.default.PropTypes.string.isRequired
};
SpeechView.defaultProps = { highlights: _immutable2.default.List.of(),
  progress: ''
};
exports.default = SpeechView;